/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_HST_H_
#define NTHW_HST_H_

#include "nthw_fpga_model.h"

struct NthwHst
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModHst;
  int mnInstance;

  int mnHstCategories;

  nthw_register_t* mpRegRcpCtrl;
  nthw_field_t* mpFldRcpCtrlAdr;
  nthw_field_t* mpFldRcpCtrlCnt;

  nthw_register_t* mpRegRcpData;
  nthw_field_t* mpFldRcpDataStripMode;
  nthw_field_t* mpFldRcpDataStartDyn;
  nthw_field_t* mpFldRcpDataStartOfs;
  nthw_field_t* mpFldRcpDataEndDyn;
  nthw_field_t* mpFldRcpDataEndOfs;
  nthw_field_t* mpFldRcpDataModif0Cmd;
  nthw_field_t* mpFldRcpDataModif0Dyn;
  nthw_field_t* mpFldRcpDataModif0Ofs;
  nthw_field_t* mpFldRcpDataModif0Value;
  nthw_field_t* mpFldRcpDataModif1Cmd;
  nthw_field_t* mpFldRcpDataModif1Dyn;
  nthw_field_t* mpFldRcpDataModif1Ofs;
  nthw_field_t* mpFldRcpDataModif1Value;
  nthw_field_t* mpFldRcpDataModif2Cmd;
  nthw_field_t* mpFldRcpDataModif2Dyn;
  nthw_field_t* mpFldRcpDataModif2Ofs;
  nthw_field_t* mpFldRcpDataModif2Value;
};

typedef struct NthwHst NthwHst_t;
typedef struct NthwHst NthwHst;

NthwHst_t* NthwHst_new(void);
void NthwHst_delete(NthwHst_t* p);
int NthwHst_init(NthwHst_t *p, nthw_fpga_t* pFpga, int nInstance);
/*  */
int NthwHst_setup(NthwHst_t* p);

#endif /* NTHW_HST_H_ */
