/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_PCM_NT50B01_V01_H_
#define NTHW_PCM_NT50B01_V01_H_

struct NthwPcm_nt50b01_v1
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPcm;
  int mnInstance;

  nthw_register_t* mpRegCtrl;
  nthw_field_t* mpFldCtrlTsClkSel;
  nthw_field_t* mpFldCtrlTsMmcmRst;

  nthw_register_t* mpRegStat;
  nthw_field_t* mpFldStatTsMmcmLocked;

  nthw_register_t* mpRegLatch;
  nthw_field_t* mpFldLatchTsMmcmLocked;

};

typedef struct NthwPcm_nt50b01_v1 NthwPcm_nt50b01_v1_t;
typedef struct NthwPcm_nt50b01_v1 NthwPcm_nt50b01_v1;

NthwPcm_nt50b01_v1_t* NthwPcm_nt50b01_v1_new(void);
void NthwPcm_nt50b01_v1_delete(NthwPcm_nt50b01_v1_t* p);
int NthwPcm_nt50b01_v1_init(NthwPcm_nt50b01_v1_t* p, nthw_fpga_t* pFpga, int nInstance);

#endif /* NTHW_PCM_NT50B01_V01_H_ */
