/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_PHY3S10G_H_
#define NTHW_PHY3S10G_H_

struct NthwPhy3s10g
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPhy3s10g;
  int mnInstance;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) LINK_SUMMARY register */
  nthw_field_t* mpLinkSummaryAbs;
  nthw_field_t* mpLinkSummaryNtLinkState;
  nthw_field_t* mpLinkSummaryAnegBypass;
  nthw_field_t* mpLinkSummaryLinkDownCnt;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CTRL register */
  nthw_field_t* mpCtrlPhySel;
  nthw_field_t* mpCtrlPhyChangeFsmDone;
  nthw_field_t* mpCtrlSoftReset;
  nthw_field_t* mpCtrlLinkupLatency;
  nthw_field_t* mpCtrlForceLinkDown;
  nthw_field_t* mpCtrlLineLoopback_3s;
  nthw_field_t* mpCtrlHostLoopback_3s;
  nthw_field_t* mpCtrlLineLoopback_10g;
  nthw_field_t* mpCtrlhostLoopback_10g;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CORE_CONF_10G register */
  nthw_field_t* mpCoreConf10gPmaLoopback;
  nthw_field_t* mpCoreConf10gPmaReset;
  nthw_field_t* mpCoreConf10gPcsLoopback;
  nthw_field_t* mpCoreConf10gPcsReset;
  nthw_field_t* mpCoreConf10gSetPmaLinkStatus;
  nthw_field_t* mpCoreConf10gClearPmaPmdLinkFaults;
  nthw_field_t* mpCoreConf10gSetPcsLinkStatus;
  nthw_field_t* mpCoreConf10gClearPcsLinkFaults;
  nthw_field_t* mpCoreConf10gClearPcsStatus2;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CORE_STAT_10G register */
  nthw_field_t* mpCoreStat10gPcsBlockLock;
  nthw_field_t* mpCoreStat10gPmaPmdLinkStat;
  nthw_field_t* mpCoreStat10gRxSigDet;
  nthw_field_t* mpCoreStat10gPcsRxLinkStatus;
  nthw_field_t* mpCoreStat10gPcsRxLocked;
  nthw_field_t* mpCoreStat10gPcsHiber;
  nthw_field_t* mpCoreStat10gTengPcsRxLinkStatus;
  nthw_field_t* mpCoreStat10gNtLinkState;
  nthw_field_t* mpCoreStat10gPcsErrBlockCount;
  nthw_field_t* mpCoreStat10gPcsBerCount;
  nthw_field_t* mpCoreStat10gPcsRxHiberLh;
  nthw_field_t* mpCoreStat10gPcsRxLockedLl;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CORE_CONF_3S register */
  nthw_field_t* mpCoreConf3sUnidirectEn;
  nthw_field_t* mpCoreConf3sLoopbackCtrl;
  nthw_field_t* mpCoreConf3sPowerDown;
  nthw_field_t* mpCoreConf3sAnegEn;
  nthw_field_t* mpCoreConf3sAnegRestart;
  nthw_field_t* mpCoreConf3sBasexOrSgmii;
  nthw_field_t* mpCoreConf3sSpeed;
  nthw_field_t* mpCoreConf3sAnegBypassEn;
  nthw_field_t* mpCoreConf3sLinkTimerBasex;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) CORE_STAT_3S register */
  nthw_field_t* mpCoreStat3sLinkStatus;
  nthw_field_t* mpCoreStat3sLinkSync;
  nthw_field_t* mpCoreStat3sRudiC;
  nthw_field_t* mpCoreStat3sRudiI;
  nthw_field_t* mpCoreStat3sRudiInvalid;
  nthw_field_t* mpCoreStat3sRxdisperr;
  nthw_field_t* mpCoreStat3sRxnotintable;
  nthw_field_t* mpCoreStat3sPhyLinkStat;
  nthw_field_t* mpCoreStat3sRemFaultEnc;
  nthw_field_t* mpCoreStat3sSpeed;
  nthw_field_t* mpCoreStat3sDuplexMode;
  nthw_field_t* mpCoreStat3sReserved;
  nthw_field_t* mpCoreStat3sPause;
  nthw_field_t* mpCoreStat3sAnegComplete;
  nthw_field_t* mpCoreStat3sNtLinkState;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) ANEG_ADV_3S register */
  nthw_field_t* mpAnegAdv3sDuplex;
  nthw_field_t* mpAnegAdv3sPause;
  nthw_field_t* mpAnegAdv3sRemoteFault;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) GPIO register */
  nthw_field_t* mpGpioAbs;
  nthw_field_t* mpGpioRxLos;
  nthw_field_t* mpGpioTxFault;
  nthw_field_t* mpGpioLedMode;
  nthw_field_t* mpGpioRateSel;
  nthw_field_t* mpGpioTxDisable;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) INT register */
  nthw_field_t* mpIntEn;
  nthw_field_t* mpIntMaxPace;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) GT_CR register */
  nthw_field_t* mpGtCrEyescanreset;
  nthw_field_t* mpGtCrEyescantrigger;
  nthw_field_t* mpGtCrRxcdrhold;
  nthw_field_t* mpGtCrTxprbsforceerr;
  nthw_field_t* mpGtCrTxpmareset;
  nthw_field_t* mpGtCrRxpmareset;
  nthw_field_t* mpGtCrTxprecursor;
  nthw_field_t* mpGtCrTxpostcursor;
  nthw_field_t* mpGtCrTxdiffctrl;
  nthw_field_t* mpGtCrTxprbssel;
  nthw_field_t* mpGtCrRxprbssel;
  nthw_field_t* mpGtCrRxprbscntreset;
  nthw_field_t* mpGtCrLoopback;
  nthw_field_t* mpGtCrRxlpmen;
  nthw_field_t* mpGtCrRxdfelpmreset;

  /* Xilinx combined tri-speed and ten gig eth PCS PMA (PHY3S10G) GT_SR register */
  nthw_field_t* mpGtSrTxresetdone;
  nthw_field_t* mpGtSrRxresetdone;
  nthw_field_t* mpGtSrRxpmaresetdone;
  nthw_field_t* mpGtSrTxbufstatus;
  nthw_field_t* mpGtSrRxbufstatus;
  nthw_field_t* mpGtSrEyescandataerror;
  nthw_field_t* mpGtSrRxprbserr;

  /* Timestamp compensation for RX path delay */
  nthw_field_t* mpTsCompRx10g;
  nthw_field_t* mpTsCompRx3S;

};

typedef struct NthwPhy3s10g NthwPhy3s10g_t;
typedef struct NthwPhy3s10g NthwPhy3s10g;

NthwPhy3s10g_t* NthwPhy3s10g_new(void);
void NthwPhy3s10g_delete(NthwPhy3s10g_t* p);
int NthwPhy3s10g_init(NthwPhy3s10g_t *p, nthw_fpga_t* pFpga, int nInstance);

void NthwPhy3s10g_ResetLatchedBits(NthwPhy3s10g_t* p);
void NthwPhy3s10g_NimTxlaser(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_GetNimTxlaser(NthwPhy3s10g_t* p, bool *pEnable);
void NthwPhy3s10g_ForceLinkDown(NthwPhy3s10g_t* p, bool forceDown);
void NthwPhy3s10g_HostLoopback3s(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_LineLoopback3s(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_HostLoopback10g(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_LineLoopback10g(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_PortStatus(NthwPhy3s10g_t* p, bool* pCurrent, bool *modDetect, uint32_t *linkDownCnt, bool *pAnegBypassed);
void NthwPhy3s10g_SetLedMode(NthwPhy3s10g_t* p, uint8_t mode);
void NthwPhy3s10g_SetTxEye(NthwPhy3s10g_t* p, uint8_t pre, uint8_t post, uint8_t diff);
void NthwPhy3s10g_Select(NthwPhy3s10g_t* p, uint8_t select);
void NthwPhy3s10g_ToggleSoftReset(NthwPhy3s10g_t* p);
void NthwPhy3s10g_GetPhyChangeFsmDone(NthwPhy3s10g_t* p, bool* pDone);
void NthwPhy3s10g_SetLinkupLatency(NthwPhy3s10g_t* p, uint32_t latency);
void NthwPhy3s10g_SetNimRate(NthwPhy3s10g_t* p, uint8_t rate);
void NthwPhy3s10g_GetGtSrTxResetDone(NthwPhy3s10g_t* p, bool*   pDone);
void NthwPhy3s10g_SetGtCrRxLpmEna(NthwPhy3s10g_t* p, bool rxLpmEna);
void NthwPhy3s10g_CoreConfAnegEna(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_CoreConfAnegByPassEna(NthwPhy3s10g_t* p, bool enable);
void NthwPhy3s10g_SetCoreConfUseBasex(NthwPhy3s10g_t* p, bool useBasex);
void NthwPhy3s10g_SetCoreConfSpeed(NthwPhy3s10g_t* p, int speed);
void NthwPhy3s10g_GetCoreStat3sSpeed(NthwPhy3s10g_t* p, int* pSpeed);
void NthwPhy3s10g_AnegComplete(NthwPhy3s10g_t* p, bool *pComplete);
void NthwPhy3s10g_setTsCompRx10g(NthwPhy3s10g_t* p, uint16_t rxDly);
void NthwPhy3s10g_setTsCompRx3S(NthwPhy3s10g_t* p, uint16_t rxDly);

#endif /* NTHW_PHY3S10G_H_ */
