/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __FLOW_NTHW_IFR_H__
#define __FLOW_NTHW_IFR_H__

#include "nthw_fpga_model.h"

struct IfrNthw {
  uint8_t mPhysicalAdapterNo;
  nthw_fpga_t *mpFpga;

  nthw_module_t *mIfr;

  nthw_register_t *mpRcpCtrl;
  nthw_field_t *mpRcpAddr;
  nthw_field_t *mpRcpCnt;

  nthw_register_t *mpRcpData;
  nthw_field_t *mpRcpDataEn;
  nthw_field_t *mpRcpDataMtu;
};

struct IfrNthw *IfrNthw_new(void);
void IfrNthw_delete(struct IfrNthw *p);
int IfrNthw_init(struct IfrNthw *p, nthw_fpga_t *pFpga, int nInstance);

int IfrNthw_setup(struct IfrNthw *p, int nIdx, int nIdxCnt);
void ifrNthw_setDebugMode(struct IfrNthw *p, unsigned int nDebugMode);

/* IFR */
void IfrNthw_RcpSelect(const struct IfrNthw *p, uint32_t val);
void IfrNthw_RcpCnt(const struct IfrNthw *p, uint32_t val);
void IfrNthw_RcpEn(const struct IfrNthw *p, uint32_t val);
void IfrNthw_RcpMtu(const struct IfrNthw *p, uint32_t val);
void IfrNthw_RcpFlush(const struct IfrNthw *p);

#endif /* __FLOW_NTHW_IFR_H__ */
