/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __FLOW_NTHW_SLC_LR_H__
#define __FLOW_NTHW_SLC_LR_H__

#include <stdint.h> /* uint32_t */
#include "nthw_fpga_model.h"

struct SlcLrNthw {
  uint8_t mPhysicalAdapterNo;
  nthw_fpga_t *mpFpga;

  nthw_module_t *mSlcLr;

  nthw_register_t *mpRcpCtrl;
  nthw_field_t *mpRcpAddr;
  nthw_field_t *mpRcpCnt;
  nthw_register_t *mpRcpData;

  nthw_field_t *mpRcpDataTailSlcEn;
  nthw_field_t *mpRcpDataTailDyn;
  nthw_field_t *mpRcpDataTailOfs;
  nthw_field_t *mpRcpDataPcap;
};

typedef struct SlcLrNthw SlcLrNthw_t;
#if 0
typedef struct SlcLrNthw SlcLrNthw;
#endif

struct SlcLrNthw *SlcLrNthw_new(void);
void SlcLrNthw_delete(struct SlcLrNthw *p);
int SlcLrNthw_init(struct SlcLrNthw *p, nthw_fpga_t *pFpga, int nInstance);

int SlcLrNthw_setup(struct SlcLrNthw *p, int nIdx, int nIdxCnt);
void slcLrNthw_setDebugMode(struct SlcLrNthw *p, unsigned int nDebugMode);

#if 0
  uint32_t GetVersionMajor(void) {return (mSlcLr.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mSlcLr.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mSlcLr.setDebugMode(Register::ON_WRITE); else mSlcLr.setDebugMode(Register::NO_DEBUG);}
#endif

/* RCP */
void SlcLrNthw_RcpSelect(const struct SlcLrNthw *p, uint32_t val);
void SlcLrNthw_RcpCnt(const struct SlcLrNthw *p, uint32_t val);
void SlcLrNthw_RcpTailSlcEn(const struct SlcLrNthw *p, uint32_t val);
void SlcLrNthw_RcpTailDyn(const struct SlcLrNthw *p, uint32_t val);
void SlcLrNthw_RcpTailOfs(const struct SlcLrNthw *p, int32_t val);
void SlcLrNthw_RcpPcap(const struct SlcLrNthw *p, uint32_t val);
void SlcLrNthw_RcpFlush(const struct SlcLrNthw *p);

#endif /* __FLOW_NTHW_SLC_LR_H__ */
