/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __FLOW_NTHW_TX_INS_H__
#define __FLOW_NTHW_TX_INS_H__

#include <stdint.h>
#include "nthw_fpga_model.h"

struct TxInsNthw {
  uint8_t mPhysicalAdapterNo;
  nthw_fpga_t *mpFpga;

  nthw_module_t *mTxIns;

  nthw_register_t *mpRcpCtrl;
  nthw_field_t *mpRcpAddr;
  nthw_field_t *mpRcpCnt;

  nthw_register_t *mpRcpData;
  nthw_field_t *mpRcpDataDyn;
  nthw_field_t *mpRcpDataOfs;
  nthw_field_t *mpRcpDataLen;
};

struct TxInsNthw *TxInsNthw_new(void);
void TxInsNthw_delete(struct TxInsNthw *p);
int TxInsNthw_init(struct TxInsNthw *p, nthw_fpga_t *pFpga, int nInstance);

int TxInsNthw_setup(struct TxInsNthw *p, int nIdx, int nIdxCnt);
void txInsNthw_setDebugMode(struct TxInsNthw *p, unsigned int nDebugMode);

#if 0
  uint32_t GetVersionMajor(void) {return (mTxIns.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mTxIns.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mTxIns.setDebugMode(Register::ON_WRITE); else mTxIns.setDebugMode(Register::NO_DEBUG);}
#endif

/* RCP */
void TxInsNthw_RcpSelect(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpCnt(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpDyn(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpOfs(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpLen(const struct TxInsNthw *p, uint32_t val);
void TxInsNthw_RcpFlush(const struct TxInsNthw *p);

#endif /* __FLOW_NTHW_TX_INS_H__ */
