/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#include "nthw_platform_drv.h"

NthwAdapterId_t NthwPlatform_GetNthwAdapterId(const uint16_t nPciDeviceId)
{
  switch (nPciDeviceId) {
    case NT_HW_PCI_DEVICE_ID_NT40E3:   return NT_HW_ADAPTER_ID_NT40E3;   break;
    case NT_HW_PCI_DEVICE_ID_NT100E3:  return NT_HW_ADAPTER_ID_NT100E3;  break;
    case NT_HW_PCI_DEVICE_ID_NT80E3:   return NT_HW_ADAPTER_ID_NT80E3;   break;
    case NT_HW_PCI_DEVICE_ID_NT40A00:  return NT_HW_ADAPTER_ID_NT40E3;   break;
    case NT_HW_PCI_DEVICE_ID_NT40A01:  return NT_HW_ADAPTER_ID_NT40E3;   break;
    case NT_HW_PCI_DEVICE_ID_NT200E3:  return NT_HW_ADAPTER_ID_NT200E3;  break;
    case NT_HW_PCI_DEVICE_ID_NT200A01: return NT_HW_ADAPTER_ID_NT200A01; break;
    case NT_HW_PCI_DEVICE_ID_NT200D01: return NT_HW_ADAPTER_ID_NT200D01; break;
    case NT_HW_PCI_DEVICE_ID_NT200A02_LENOVO:
    case NT_HW_PCI_DEVICE_ID_NT200A02: return NT_HW_ADAPTER_ID_NT200A02; break;
    case NT_HW_PCI_DEVICE_ID_NT50B01_LENOVO:
    case NT_HW_PCI_DEVICE_ID_NT50B01:  return NT_HW_ADAPTER_ID_NT50B01;  break;
    case NT_HW_PCI_DEVICE_ID_NT100A01: return NT_HW_ADAPTER_ID_NT100A01; break;
    default:                           return NT_HW_ADAPTER_ID_UNKNOWN;  break;
  }
}
